"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerGermlineVariantLevelQuestions(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "validationAssayType",
        "variantDetails",
        "variantTested",
        "variantUsability",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "variantTested": reports_4_2_0.CancerTested,
            "variantUsability": reports_4_2_0.CancerUsabilityGermline,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.CancerTested": reports_4_2_0.CancerTested,
            "org.gel.models.report.avro.CancerUsabilityGermline": reports_4_2_0.CancerUsabilityGermline,
            "org.gel.models.report.avro.CancerGermlineVariantLevelQuestions": reports_4_2_0.CancerGermlineVariantLevelQuestions,
        }

    __slots__ = [
        "validationAssayType",
        "variantDetails",
        "variantTested",
        "variantUsability",
    ]

    def __init__(
        self,
        validationAssayType,
        variantDetails,
        variantTested,
        variantUsability,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.CancerGermlineVariantLevelQuestions model.

        :param validationAssayType:
            Please enter validation assay type e.g Pyrosequencing, NGS panel,
            COBAS, Sanger sequencing. If not applicable enter NA;
        :type validationAssayType: str
        :param variantDetails:
            Chr: Pos Ref > Alt
        :type variantDetails: str
        :param variantTested:
            Has this variant been tested by another method (either prior to or
            following receipt of this WGA)?
        :type variantTested: CancerTested
        :param variantUsability:
            How has/will this potentially actionable variant been/be used?
        :type variantUsability: CancerUsabilityGermline
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
